* core.s

	.include	core.mac
	.include	../twin.mac
	.include	../twin_version.mac

	.xdef	coretable
	.xdef	coreno
	.xdef	coreuse
	.xdef	coreblinkmode
	.xdef	__core_entry
	.xdef	__core_set
	.xdef	__core_reset
	.xdef	__core_check
	.xdef	__core_init


*-------------------------------------------------------------------------------
* 풓[N

	.bss
coretable:
	.ds.b	coretablesize

	.data
coreno:
	.dcb.b	COREMAX,0
	.dc.b	1			* Xgbp[
coreblinkmode:
	.dcb.b	COREMAX,0
	.even
coreuse:
	.dcb.w	TWINMAX,-1

coreinit_flag:
	.dc.b	0

*-------------------------------------------------------------------------------
* 풓CuGg
*
* entry:
*	d0.l = 0 [`̊Jn錾
*	d0.l = 1 [`̏I錾
*	d0.l = 2 [`̃`FbN
*	d0.l = 3 coretablẽAhX𓾂

	.data
	.quad
__core_entry_table:
	.dc.l	__core_set		* 0
	.dc.l	__core_reset		* 1
	.dc.l	__core_check		* 2
	.dc.l	__core_gettable		* 3
	.dc.l	__core_reserve		* 4
	.dc.l	__core_reserve		* 5
	.dc.l	__core_reserve		* 6
	.dc.l	__core_reserve		* 7
	.dc.l	__core_reserve		* 8
	.dc.l	__core_reserve		* 9
	.dc.l	__core_reserve		* 10
	.dc.l	__core_reserve		* 11
	.dc.l	__core_reserve		* 12
	.dc.l	__core_reserve		* 13
	.dc.l	__core_reserve		* 14
	.dc.l	__core_reserve		* 15

	.text
__core_entry:
	move.l	a0,-(sp)
	cmp.l	#15,d0
	bhi	__core_entry_error

	add.l	d0,d0
	add.l	d0,d0
	lea	__core_entry_table,a0
	move.l	(a0,d0.l),a0
	jsr	(a0)
__core_entry_end:
	move.l	(sp)+,a0
	rts

__core_entry_error:
	moveq.l	#-1,d0
	bra	__core_entry_end

*-------------------------------------------------------------------------------
* VXeU[u

	.text
__core_reserve:
	rts

*-------------------------------------------------------------------------------
* core ̃e[uAhX𓾂

	.text
__core_gettable:
	move.l	#coretable,d0
	rts

*-------------------------------------------------------------------------------
* core ̗pJn

	.text
__core_set:
	move.l	a0,-(sp)
	tst.b	coreinit_flag
	beq	__core_set_error

	lea	coreno,a0
@@:	tas.b	(a0)+
	bmi	@b			* gp
	bne	__core_set_error	* pĂvO߂

	subq.l	#1,a0
	sub.l	#coreno,a0
	move.l	a0,d0			* core pio
__core_set_end:
	move.l	(sp)+,a0
	rts

__core_set_error:
	moveq.l	#-1,d0
	bra	__core_set_end

*-------------------------------------------------------------------------------
* core ̗pI

	.text
__core_reset:
	move.l	a0,-(sp)
	tst.b	coreinit_flag
	beq	__core_reset_error

	clr.l	d0
	move.w	d1,d0
	cmp.w	#COREMAX,d0
	bhi	__core_reset_error

	lea	coreno,a0
	tst.b	(a0,d0.w)
	bpl	__core_reset_error

	clr.b	(a0,d0.w)		* tO
	clr.l	d0
__core_reset_end:
	move.l	(sp)+,a0
	rts

__core_reset_error:
	moveq.l	#-1,d0
	bra	__core_reset_end

*-------------------------------------------------------------------------------
* core ̗p󋵂𒲂ׂ

	.text
__core_check:
	move.l	a0,-(sp)
	tst.b	coreinit_flag
	beq	__core_check_error

	lea	coreno,a0
	moveq.l	#0-1,d0
@@:
	addq.w	#1,d0
	tst.b	(a0,d0.w)
	beq	@b			* gp
	bmi	__core_check_error

	clr.l	d0			* ɗpĂȂ
__core_check_end:
	move.l	(sp)+,a0
	rts

__core_check_error:
	moveq.l	#-1,d0			* ܂pĂ
	bra	__core_check_end

*-------------------------------------------------------------------------------
* }N`

CORE_TABLE	.macro	%name
	.xref	_%name
	move.l	#_%name,core_%name(a0)
	.endm

CORE_TABLE_FIX	.macro	%name
	.xref	_c_%name
	move.l	#_c_%name,core_%name(a0)
	.endm

*-------------------------------------------------------------------------------
* core ̃e[u

	.text
__core_init:
	move.l	a0,-(sp)
	tst.b	coreinit_flag
	bne	__core_init_error

	lea	coretable,a0
	CORE_TABLE_FIX	twinopen
	CORE_TABLE_FIX	twinclose
	CORE_TABLE_FIX	twincloseall
	CORE_TABLE	twinresize
	CORE_TABLE	twinconsol
	CORE_TABLE	twinlocate
	CORE_TABLE	twincolor
	CORE_TABLE_FIX	twincuron
	CORE_TABLE	twincuroff
	CORE_TABLE	twindraw
	CORE_TABLE	twinredraw
	CORE_TABLE	twinclear
	CORE_TABLE	twincls
	CORE_TABLE	twinprint
	CORE_TABLE	twinputc
	CORE_TABLE	twinputfnt
	CORE_TABLE	twinworksize
	CORE_TABLE_FIX	twinblinkon
	CORE_TABLE_FIX	twinblinkoff
	CORE_TABLE	getfonttable
	CORE_TABLE	tycopy
	CORE_TABLE	tclr
	CORE_TABLE	tclr3
	CORE_TABLE	trev
	CORE_TABLE	trev3
	CORE_TABLE	teor2
	CORE_TABLE	tput
	CORE_TABLE	tput3
	CORE_TABLE	tget
	CORE_TABLE	_tputs
	CORE_TABLE	_tycopy
	CORE_TABLE	_tclr
	CORE_TABLE	_tclr3
	CORE_TABLE	_trev
	CORE_TABLE	_trev3
	CORE_TABLE	_teor2
	CORE_TABLE	_tput
	CORE_TABLE	_tput3
	CORE_TABLE	_tget
	move.b	#1,coreinit_flag
	clr.l	d0
__core_init_end:
	move.l	(sp)+,a0
	rts

__core_init_error:
	moveq.l	#-1,d0
	bra	__core_init_end

	.end
