* core_twininit.s

	.include	doscall.mac
	.include	core.mac
	.include	../twin.mac
	.include	../twin_version.mac

	.xdef	_twininit
	.xdef	twincore_entry
	.xdef	twincore_version
	.xdef	twincore_no
	.xdef	twincore_base
	.xdef	twincore_flag
	.xdef	twincore_init_flag


*-------------------------------------------------------------------------------
* 풓[N

	.bss
	.quad
twincore_entry:
	.ds.l	1
twincore_version:
	.ds.w	1
twincore_no:
	.ds.w	1
twincore_base:
	.ds.b	coretablesize

	.data
twincore_flag:
	.dc.b	0
twincore_init_flag:
	.dc.b	0
twincore_name:
	.dc.b	'twincore'
	.dc.b	0
	TWIN_VERSION_STRING
	.dc.b	0


*-------------------------------------------------------------------------------
* twin 
*
* int twininit( void );
*
* return:
*	 0 >= core pio.
*	-1 =  core płȂ.
*	-2 =  core Ȃ.(풓ĂȂ)
*	-3 =  core ̃o[WÂ.
*	-4 =  core ̃o[WV.

	.text
_twininit:
	tas.b	twincore_flag
	bne	_twininit_error

	lea	twincore_name,a0
	move.l	#$100+10,d0
	bsr	keep_check
	tst.l	d0			* 0
	beq	_twininit_not_found
	subq.l	#1,d0			* 1
	beq	_twininit_ok
	subq.l	#1,d0			* 2
	beq	_twininit_version_check
	bra	_twininit_error

_twininit_version_check:
	move.w	$100+8(a0),d0
	move.w	#TWIN_VERSION,d1
	and.w	#$0ff0,d0
	and.w	#$0ff0,d1
	cmp.w	d1,d0
	bcs	_twininit_version_old	* }Ci[o[WȏオύXĂ.
	bhi	_twininit_version_new
_twininit_ok:
	move.l	$100+4(a0),twincore_entry
	move.w	$100+8(a0),twincore_version
	move.l	twincore_entry,a0

	moveq.l	#0,d0			* Jn錾
	jsr	(a0)
	tst.l	d0
	bmi	_twininit_error		* core̗pɎs
	move.w	d0,twincore_no

	moveq.l	#3,d0			* Wve[u߂
	jsr	(a0)
	tst.l	d0
	bmi	_twininit_error		* core̗pɎs
	move.l	d0,a2
	move.w	#coretablesize,d0
	lsr.w	#2,d0
	subq.w	#1,d0
	bmi	1f
	lea	twincore_base,a1
@@:	move.l	(a2)+,(a1)+		* WvxN^Rs[
	dbra	d0,@b
1:
	bsr	__exit_hook		* ُexittwinends

	clr.l	d0
	move.w	twincore_no,d0
	move.b	#1,twincore_init_flag
_twininit_end:
	rts

_twininit_error:
	moveq.l	#-1,d0
_twininit_error_exit:
	bsr	_twininit_error_table_clear
	bra	_twininit_end

_twininit_not_found:
	moveq.l	#-2,d0
	bra	_twininit_error_exit

_twininit_version_old:
	moveq.l	#-3,d0
	bra	_twininit_error_exit

_twininit_version_new:
	moveq.l	#-4,d0
	bra	_twininit_error_exit

_twininit_error_table_clear:
	movem.l	d0/a0-a1,-(sp)
	move.w	#coretablesize,d0
	lsr.w	#2,d0
	subq.w	#1,d0
	bmi	1f
	lea	twincore_base,a0
	lea	_twininit_rts(pc),a1
@@:	move.l	a1,(a0)+
	dbra	d0,@b
1:	movem.l	(sp)+,d0/a0-a1
	rts

_twininit_rts:
	rts

*-------------------------------------------------------------------------------
* [`̓o^

	.text
ctrlc_old:
	.dc.l	0
abort_old:
	.dc.l	0

	.text
__exit_hook:
	pea	__exit_ctrlc(pc)
	move.w	#$fff1,-(sp)
	DOS	__INTVCS
	move.l	d0,ctrlc_old
	addq.l	#6,sp

	pea	__exit_abort(pc)
	move.w	#$fff2,-(sp)
	DOS	__INTVCS
	move.l	d0,abort_old
	addq.l	#6,sp
	rts

__exit_ctrlc:
	move.w	twincore_no,-(sp)
	clr.w	-(sp)
	jsr	_twinend
	addq.l	#4,sp
	move.l	ctrlc_old,-(sp)
	rts

__exit_abort:
	move.w	twincore_no,-(sp)
	clr.w	-(sp)
	jsr	_twinend
	addq.l	#4,sp
	move.l	abort_old,-(sp)
	rts


*-------------------------------------------------------------------------------
* }N`

_TO_SUPER	.macro
* X[p[oCU[[h
	clr.l	-(sp)
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,-(sp)
	.endm

_TO_USER	.macro
		.local	super_end
* [U[[h
	move.l	(sp)+,d0
	bmi	super_end
	move.l	d0,-(sp)
	DOS	__SUPER
	addq.l	#4,sp
super_end:
	.endm

*-------------------------------------------------------------------------------
* 풓`FbN
*
* entry:
*   a0.l = ʕ (name + versionݒ肷邱)
*   d0.l = ʕ̃ItZbg
* return:
*   d0.l = 0 vO܂
*        = 1 łɏ풓ς݂ł
*        = 2 o[WႢł
*        = 3 G[ł (͕ۏ؂܂)
*   a0.l = Ǘ|C^̃AhX (d0.l = 1, 2̎AȊO͕s)

keep_check_register	reg	d1-d5/a1-a3

	.text
keep_check:
	movem.l	keep_check_register,-(sp)
	move.l	a0,a2
	move.l	d0,d2			* d2.l = ʕ̐擪܂ł̃ItZbg
	DOS	__GETPDB
	move.l	d0,a3
	sub.w	#$10,a3			* a3.l = ̃Ǘ|C^̃AhX

	moveq.l	#-1,d4
keep_check_name_length:
	addq.l	#1,d4
	tst.b	(a0)+
	bne	keep_check_name_length
					* d4.l = name̒îO܂܂Ȃj
	moveq.l	#-1,d5
keep_check_version_length:
	addq.l	#1,d5
	tst.b	(a0)+
	bne	keep_check_version_length
					* d5.l = version̒îO܂܂Ȃj
	move.l	d2,d3
	add.l	d4,d3
	add.l	d5,d3
	addq.l	#2,d3			* d3.l = ʕŌ̂O܂ł̃ItZbg

	_TO_SUPER

	move.l	a3,a0			* ̃Ǘ|C^eǂ
keep_check_backward_loop:
	tst.l	$04(a0)			* e邩H
	beq	keep_check_forward_loop
	move.l	$04(a0),a0		* ẽǗ|C^𓾂
	bra	keep_check_backward_loop

keep_check_forward_loop:
	move.l	$0c(a0),d0
	beq	keep_check_not_found	* Ȃ
	move.l	d0,a0
	move.l	$08(a0),d0
	lea	(a0,d3.l),a1
	cmp.l	a1,d0
	bls	keep_check_forward_loop	* ubN͈̔͊O
	lea	(a0,d2.l),a1
	cmp.l	a1,a2
	beq	keep_check_forward_loop	* gEEE

keep_check_forward_name:
	move.l	a2,d1
	move.l	d4,d0
keep_check_forward_name_compare:
	cmpm.b	(a2)+,(a1)+
	dbne	d0,keep_check_forward_name_compare
	beq	keep_check_forward_version
	move.l	d1,a2
	bra	keep_check_forward_loop	* name 玟ɂ

keep_check_forward_version:
	move.l	d5,d0
keep_check_forward_version_compare:
	cmpm.b	(a2)+,(a1)+
	dbne	d0,keep_check_forward_version_compare
	bne	keep_check_version_no_match	* o[WႤ݂Ȃ
	bra	keep_check_match

keep_check_not_found:
	moveq.l	#0,d0
	bra	keep_check_end

keep_check_match:
	moveq.l	#1,d0
	bra	keep_check_end

keep_check_version_no_match:
	moveq.l	#2,d0
	bra	keep_check_end

keep_check_error:
	moveq.l	#3,d0

keep_check_end:
	move.l	d0,d1
	_TO_USER
	move.l	d1,d0
	movem.l	(sp)+,keep_check_register
	rts

	.end
